.\"========================================================================
.\"
.\" Name - xgrab.man
.\"
.\" ccs version: 1.8
.\"
.\" ccsid:	@(#)xgrab.man	1.8 - 06/25/93 13:29:31
.\" from: 	ccs/s.xgrab.man
.\" date: 	06/28/93 09:14:49
.\"
.\" Copyright (C) 1990-92 Bruce Schuchardt
.\" See the end of this document for full copyright information.
.\"
.\" Description:  Man page for xgrab
.\"
.\"========================================================================
.\"
.TH XGRAB 1X
.\"
.SH NAME
xgrab \- interactive front for xgrabsc, an X-Windows image grabber
.\"
.SH SYNOPSIS
.in +8n
.ti -8n
\fIxgrab\fR
.in -8n
.\"
.SH DESCRIPTION
\fIxgrab\fR lets you grab arbitrary rectangular images from an
X server and writes them to files or commands (such as lpr) in
a variety of formats.
.PP
\fIxgrab\fR is a front for the xgrabsc program.
Read the man page for \fIxgrabsc\fR for a description of the options
presented by xgrab.
.PP
After selecting options from the various categories presented, press
the \fIOK\fR button to have xgrab run xgrabsc to let you grab an image
from the screen.  After you press \fIOK\fP, xgrab's window will disappear
and xgrabsc will gain control until the grabbing process is finished.
Afterwards, the xgrab window will reappear.
.sp 2
.SH OPTIONS
Xgrab responds to the standard application options, such as \fI-display\fP.
See the man page for \fIX\fP for a complete list.
.sp
You can also override the default xgrab settings in your .Xdefaults.  See
the examples section below for instructions.
.sp 2
.SH RESOURCES
The XGrab resource file, XGrab.ad, contains a complete specification of the
resources of all the widgets used in the xgrab window.  Global resources,
such as default font and color, are at the bottom of the file.
.sp 2
.SH EXAMPLES
The \fITo Command\fR output option may be used to pipe xgrabsc output
to programs.  The most common commands are \fIlpr\fR for Postscript
output, and \fIxwud\fR for X-Window Dump output.  Programs that do not
accept piped input should not be used in \fITo Command\fR.
.sp
You can also get fancy and pipe the output through more than one command,
such as \fItee screen.dmp | xwud\fP, to store the grabbed image and get
a preview window.
.sp 2
Default settings for xgrab can be made in your .Xdefaults file.  For
the Athena toolkit version of xgrab, Toggle
buttons can be set/unset through their \fI.state\fP attribute, and text
field strings can be set through their \fI*string\fP attribute.  For
the Motif toolkit version (which has diamond-shaped buttons for radio
buttons), toggle buttons can be set/unset through their \fI.set\fP
attribute and text field strings can be set through their \fI*value\fP
attribute.
.sp
For
example, to set the default paper size for postscript output, put these
lines in your .Xdefaults (and use xrdb to load them into the server!):
.sp
XGrab*.pageWidthText*string:   8.5
.br
XGrab*.pageHeightText*string: 11.0
.sp
or
.sp
XGrab*.pageWidthText*value:    8.5
.br
XGrab*.pageHeightText*value:  10.0
.sp
To set the default output type to \fIXWD\fP, put these lines in
your .Xdefaults:
.sp
XGrab*.ps.state:  0
.br
XGrab*.xwd.state: 1
.sp 2
.SH LIMITATIONS
See the limitations listed in the xgrabsc man page.
.sp 2
.SH AUTHOR
.nf
     Bruce Schuchardt
    Servio Corporation
      bruce@slc.com
.fi
.sp 2
.SH ACKNOWLEGEMENTS
.PP
See the xgrabsc man page, and the Acks file in the xgrabsc distribution
for a list of acknowledgements.
.sp 2
.SH COPYRIGHT
Copyright (c) 1991-93 Bruce Schuchardt
.PP
\fIXgrab\fR is copywritten material with a very loose copyright
allowing unlimited modification and distribution if the copyright
notices are left intact.  Various portions are copywritten by various
people, but all use a modification of the MIT copyright notice.
Please check the source for complete copyright information.  The
intent is to keep the source free, not to stifle its distribution, so
please write to me if you have any questions.
.PP
THE AUTHOR DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN
NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, INDIRECT OR
CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS
OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE
OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE
USE OR PERFORMANCE OF THIS SOFTWARE.
.s 2
.SH SEE ALSO
X(1X), xgrabsc(1X), xhost(1), xwd(1X), xwud(1X), xloadimage(1X), xpm(1X),
xpr(1X), ad2c(1)
